%Financial mathematics
%Black Scholes formula for dividend and non dividend palying stock;
%This is a copy right of Krishna Prasad, IIT Delhi,New Delhi
%For further information email to kprasad.iitd@gmail.com or +919891370585
%%Start of coding, Symbols have their usual meaning 
s0 =input('Enter the stock price at t = 0 : S0 =  ');
k = input('Enter the strike price for underlying asset ');
r = input('Enter the risk free rate of interest ');
T=  input('Enter the expiry time ');
sigma=input('Enter the volatility for underlying asset ');
CH = 1;
while CH == 1
    fprintf('1 : for Dividend \n 2 : non Dividend \n ');
    choice = input(' choice ');
    switch choice %for Dividend and non dividend 
        case 1
            disp('DATA For Dividend paying  Stocks ');
            dtime = input('Enter the time in  array  ');
            damount = input('Enter the dividend paying amount in array ');
            rd = -r*dtime;
            erd = exp(rd);
            ds = damount.*erd;
            sa = s0-sum(sum(ds));
            lsa = (log(sa/k)+(r+(sigma*sigma)/2)*T);
            d1 = lsa/(sigma*sqrt(T));
            d2 = d1 - sigma*sqrt(T);
            
            fprintf('1 : call option \n2 : put option \n ');
            ch = input(' choice for put or call '); 
            if ch == 1 %for call option
                c0 = sa*normcdf(d1)-k*exp(-r*T)*normcdf(d2);
                fprintf('The value of call option price is C0 = %4.4f\n',c0);
            end
            if ch == 2 % for put option
                p0 = k*exp(-r*T)*normcdf(-d2)-sa*normcdf(-d1);
                fprintf('The value of put option price is C0 = %4.4f\n',p0);
            end
            if ch ~=1 && ch~=2
                disp('In valid choice');
            end
        case 2 % for non dividend 
            lso = (log(s0/k)+(r+(sigma.*sigma)/2)*T);
            d1 = lso/(sigma*sqrt(T));
            d2 = d1 - sigma*sqrt(T);
            fprintf('1 : call option \n 2 : put option \n ');
            ch = input(' choice for put or call ');
            if ch == 1 % call option
                c0 = s0*normcdf(d1)-k*exp(-r*T)*normcdf(d2);
                fprintf('\nThe value of call option price is C0 = %f\n',c0);
            end
            if ch == 2 % put option
                c0 = s0*normcdf(d1)-k*exp(-r*T)*normcdf(d2);
                p0 = c0-s0+k*exp(-r*T);
                fprintf('\nThe value of put option price is C0 = %4.4f\n',p0);
            end
            if ch ~=1 && ch~=2
                disp('In valid choice');
            end
    end
    CH = input('1 : For more option pricing otherwise any no : ');
end